import { IResourceComponentsProps } from '@refinedev/core'
import Link from '@mui/material/Link'

import { List, useDataGrid } from '@refinedev/mui'

import {
  DataGrid,
  GridColDef,
  GridValueFormatterParams
} from '@mui/x-data-grid'

import { OperationsLogRecord } from '../../api/api'

const columns: Array<GridColDef<OperationsLogRecord>> = [
  {
    field: 'operation',
    headerName: 'Operation',
    type: 'string',
    width: 200
  },
  {
    field: 'id',
    headerName: 'FDO',
    type: 'string',
    width: 200
  }
]

export const LoggingList: React.FC<IResourceComponentsProps> = () => {
  const { dataGridProps } = useDataGrid<OperationsLogRecord>({
    resource: 'fdo'
  })

  const rows = dataGridProps.rows.map((record: OperationsLogRecord, index) => {
    return { id: record?.attributes?.fdo?.pid, operation: record?.attributes?.operation }
  })

  return (
    <List>
      <DataGrid {...dataGridProps} rows={rows} columns={columns} autoHeight />
    </List>
  )
}
