import { IResourceComponentsProps } from '@refinedev/core'
import Link from '@mui/material/Link'

import { List, useDataGrid } from '@refinedev/mui'

import {
  DataGrid,
  GridColDef,
  GridValueFormatterParams
} from '@mui/x-data-grid'

import IRepository from '../../interfaces/IRepository'

const columns: Array<GridColDef<IRepository>> = [
  {
    field: 'id',
    headerName: 'ID',
    type: 'string',
    width: 200,
    renderCell: (params) => {
      return <Link href={'./repositories/' + params.value}>{params.value}</Link>
    }
  }
]

export const RepositoriesList: React.FC<IResourceComponentsProps> = () => {
  const { dataGridProps } = useDataGrid<IRepository>()

  return (
    <List>
      <DataGrid {...dataGridProps} columns={columns} autoHeight />
    </List>
  )
}
